Index: /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/TagNames.pod
===================================================================
--- /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/TagNames.pod	(revision 34920)
+++ /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/TagNames.pod	(revision 34921)
@@ -7290,16 +13184,85 @@
      21    FlashGroupCOutput                    int8u
            FlashGroupCCompensation              int8s
+     27    ExternalFlashCompensation            int8s
+     29    FlashExposureComp3                   int8s
+     39    FlashExposureComp4                   int8s
+
+=head3 Nikon FlashInfo0106 Tags
+
+These tags are used by the Df, D610, D3300, D5300, D7100 and Coolpix A.
+
+  Index1   Tag Name                             Writable
+  ------   --------                             --------
+      0    FlashInfoVersion                     no
+      4    FlashSource                          int8u
+      6    ExternalFlashFirmware                int8u[2]
+      8    ExternalFlashFlags                   int8u
+    9.1    FlashCommanderMode                   int8u & 0x80
+    9.2    FlashControlMode                     int8u & 0x7f
+     12    FlashFocalLength                     int8u
+     13    RepeatingFlashRate                   int8u
+     14    RepeatingFlashCount                  int8u
+     15    FlashGNDistance                      int8u
+     16    FlashColorFilter                     int8u
+   17.1    FlashGroupAControlMode               int8u & 0x0f
+   18.1    FlashGroupBControlMode               int8u & 0xf0
+   18.2    FlashGroupCControlMode               int8u & 0x0f
+     39    FlashOutput                          int8u
+           FlashCompensation                    int8s
+     40    FlashGroupAOutput                    int8u
+           FlashGroupACompensation              int8s
+     41    FlashGroupBOutput                    int8u
+           FlashGroupBCompensation              int8s
+     42    FlashGroupCOutput                    int8u
+           FlashGroupCCompensation              int8s
+
+=head3 Nikon FlashInfo0107 Tags
+
+These tags are used by the D4S, D750, D810, D5500, D7200 (FlashInfoVersion
+0107) and the D5, D500, D850 and D3400 (FlashInfoVersion 0108).
+
+  Index1   Tag Name                             Writable
+  ------   --------                             --------
+      0    FlashInfoVersion                     no
+      4    FlashSource                          int8u
+      6    ExternalFlashFirmware                int8u[2]
+    8.1    ExternalFlashZoomOverride            int8u & 0x80
+    8.2    ExternalFlashStatus                  int8u & 0x01
+    9.1    ExternalFlashReadyState              int8u & 0x07
+     10    FlashCompensation                    int8s
+     12    FlashFocalLength                     int8u
+     13    RepeatingFlashRate                   int8u
+     14    RepeatingFlashCount                  int8u
+     15    FlashGNDistance                      int8u
+   17.1    FlashGroupAControlMode               int8u & 0x0f
+   18.1    FlashGroupBControlMode               int8u & 0xf0
+   18.2    FlashGroupCControlMode               int8u & 0x0f
+     40    FlashGroupAOutput                    int8u
+           FlashGroupACompensation              int8s
+     41    FlashGroupBOutput                    int8u
+           FlashGroupBCompensation              int8s
+     42    FlashGroupCOutput                    int8u
+           FlashGroupCCompensation              int8s
+
+=head3 Nikon FlashInfo0300 Tags
+
+  Index1   Tag Name                             Writable
+  ------   --------                             --------
+      0    FlashInfoVersion                     no
+      4    FlashSource                          int8u
+      6    ExternalFlashFirmware                int8u[2]
+     27    FlashCompensation                    int8s
 
 =head3 Nikon FlashInfoUnknown Tags
 
-   Index   Tag Name                             Writable
-   -----   --------                             --------
-      0    FlashInfoVersion                     N
+  Index1   Tag Name                             Writable
+  ------   --------                             --------
+      0    FlashInfoVersion                     no
 
 =head3 Nikon MultiExposure Tags
 
-   Index   Tag Name                             Writable
-   -----   --------                             --------
-      0    MultiExposureVersion                 N
+  Index4   Tag Name                             Writable
+  ------   --------                             --------
+      0    MultiExposureVersion                 no
       1    MultiExposureMode                    int32u
       2    MultiExposureShots                   int32u
@@ -7310,14 +13273,21 @@
 These tags are written by Nikon DSLR's which have the live view feature.
 
-   Index   Tag Name                             Writable
-   -----   --------                             --------
-      0    AFInfo2Version                       N
+  Index1   Tag Name                             Writable
+  ------   --------                             --------
+      0    AFInfo2Version                       no
       4    ContrastDetectAF                     int8u
       5    AFAreaMode                           int8u
       6    PhaseDetectAF                        int8u
       7    PrimaryAFPoint                       int8u
-      8    AFPointsUsed                         undef[7]~
+      8    AFPointsUsed                         undef[7]
            AFPointsUsed                         undef[2]
-           AFPointsUsed                         undef[7]~
+           AFPointsUsed                         undef[5]
+           AFPointsUsed                         undef[17]
+           AFPointsUsed                         undef[21]
+           AFPointsUsed                         undef[29]
+           AFPointsUsed                         undef[20]
+           AFPointsUsed                         undef[13]
+           AFPointsUsed                         undef[7]
+     10    AFPointsUsed                         undef[14]
      16    AFImageWidth                         int16u
      18    AFImageHeight                        int16u
@@ -7327,20 +13297,55 @@
      26    AFAreaHeight                         int16u
      28    ContrastDetectAFInFocus              int8u
+           AFPointsSelected                     undef[20]
+     42    AFImageWidth                         int16u
+     44    AFImageHeight                        int16u
+     46    AFAreaXPosition                      int16u
+     47    AFFocusPointXPosition                int8u~
+     48    AFAreaYPosition                      int16u
+           AFPointsInFocus                      undef[20]
+     49    AFFocusPointYPosition                int8u~
+     50    AFAreaWidth                          int16u
+     52    AFAreaHeight                         int16u
+     56    PrimaryAFPoint                       int8u
+     68    PrimaryAFPoint                       int8u
+     70    AFImageWidth                         int16u
+     72    AFImageHeight                        int16u
+     74    AFAreaXPosition                      int16u
+     76    AFAreaYPosition                      int16u
+     78    AFAreaWidth                          int16u
+     80    AFAreaHeight                         int16u
+     82    ContrastDetectAFInFocus              int8u
 
 =head3 Nikon FileInfo Tags
 
-   Index   Tag Name                             Writable
-   -----   --------                             --------
-      0    FileInfoVersion                      N
-      6    DirectoryNumber                      int16u
-      8    FileNumber                           int16u
+  Index2   Tag Name                             Writable
+  ------   --------                             --------
+      0    FileInfoVersion                      no
+      2    MemoryCardNumber                     int16u
+      3    DirectoryNumber                      int16u
+      4    FileNumber                           int16u
 
 =head3 Nikon AFTune Tags
 
-   Index   Tag Name                             Writable
-   -----   --------                             --------
+  Index1   Tag Name                             Writable
+  ------   --------                             --------
       0    AFFineTune                           int8u
       1    AFFineTuneIndex                      int8u
       2    AFFineTuneAdj                        int8s
+      3    AFFineTuneAdjTele                    int8s
+
+=head3 Nikon RetouchInfo Tags
+
+  Index1   Tag Name                             Writable
+  ------   --------                             --------
+      0    RetouchInfoVersion                   no
+      5    RetouchNEFProcessing                 int8s
+
+=head3 Nikon BarometerInfo Tags
+
+  Index1   Tag Name                             Writable
+  ------   --------                             --------
+      0    BarometerInfoVersion                 no
+      6    Altitude                             int32s
 
 =head3 Nikon CaptureOffsets Tags
@@ -7348,7 +13353,7 @@
   Tag ID   Tag Name                             Writable
   ------   --------                             --------
-  0x0001   IFD0_Offset                          N
-  0x0002   PreviewIFD_Offset                    N
-  0x0003   SubIFD_Offset                        N
+  0x0001   IFD0_Offset                          no
+  0x0002   PreviewIFD_Offset                    no
+  0x0003   SubIFD_Offset                        no
 
 =head3 Nikon Scan Tags
@@ -7373,18 +13378,18 @@
 =head3 Nikon ROC Tags
 
-   Index   Tag Name                             Writable
-   -----   --------                             --------
+  Index4   Tag Name                             Writable
+  ------   --------                             --------
       0    DigitalROC                           int32u
 
 =head3 Nikon GEM Tags
 
-   Index   Tag Name                             Writable
-   -----   --------                             --------
+  Index4   Tag Name                             Writable
+  ------   --------                             --------
       0    DigitalGEM                           int32u
 
 =head3 Nikon CaptureOutput Tags
 
-   Index   Tag Name                             Writable
-   -----   --------                             --------
+  Index4   Tag Name                             Writable
+  ------   --------                             --------
       2    OutputImageWidth                     int32u
       3    OutputImageHeight                    int32u
@@ -7395,24 +13400,42 @@
   Tag ID   Tag Name                             Writable
   ------   --------                             --------
-  0x0003   Quality                              Y
-  0x0004   ColorMode                            Y
-  0x0005   ImageAdjustment                      Y
-  0x0006   CCDSensitivity                       Y
-  0x0007   WhiteBalance                         Y
-  0x0008   Focus                                Y
-  0x000a   DigitalZoom                          Y
-  0x000b   Converter                            Y
+  0x0003   Quality                              yes
+  0x0004   ColorMode                            yes
+  0x0005   ImageAdjustment                      yes
+  0x0006   CCDSensitivity                       yes
+  0x0007   WhiteBalance                         yes
+  0x0008   Focus                                yes
+  0x000a   DigitalZoom                          yes
+  0x000b   Converter                            yes
+
+=head3 Nikon NEFInfo Tags
+
+As-yet unknown information found in SubIFD1 tag 0xc7d5 of NEF images from
+cameras such as the Z6 and Z7, and NRW images from some Coolpix cameras.
+
+  Tag ID   Tag Name                             Writable
+  ------   --------                             --------
+  [no tags known]
 
 =head3 Nikon NCDT Tags
 
-Nikon-specific QuickTime tags found in the NCDT atom of MOV videos from some
-Nikon cameras such as the Coolpix S8000.
+Nikon-specific QuickTime tags found in the NCDT atom of MOV videos from
+various Nikon models.
 
   Tag ID   Tag Name                             Writable
   ------   --------                             --------
-  'NCHD'   MakerNoteVersion                     N
+  'NCDB'   NikonNCDB                            Nikon NCDB
+  'NCHD'   MakerNoteVersion                     no
+  'NCM1'   PreviewImage1                        no
+  'NCM2'   PreviewImage2                        no
   'NCTG'   NikonTags                            Nikon NCTG
-  'NCTH'   ThumbnailImage                       N
-  'NCVW'   PreviewImage                         N
+  'NCTH'   ThumbnailImage                       no
+  'NCVW'   PreviewImage                         no
+
+=head3 Nikon NCDB Tags
+
+  Tag ID   Tag Name                             Writable
+  ------   --------                             --------
+  [no tags known]
 
 =head3 Nikon NCTG Tags
@@ -7423,25 +13446,84 @@
   Tag ID       Tag Name                         Writable
   ------       --------                         --------
-  0x0001       Make                             N
-  0x0002       Model                            N
-  0x0003       Software                         N
-  0x0011       CreateDate                       N
-  0x0012       DateTimeOriginal                 N
-  0x0013       FrameCount                       N
-  0x0016       FrameRate                        N
-  0x0022       FrameWidth                       N
-  0x0023       FrameHeight                      N
-  0x0032       AudioChannels                    N
-  0x0033       AudioBitsPerSample               N
-  0x0034       AudioSampleRate                  N
-  0x2000001    MakerNoteVersion                 N
-  0x2000005    WhiteBalance                     N
-  0x200000b    WhiteBalanceFineTune             N
-  0x200001e    ColorSpace                       N
+  0x0001       Make                             no
+  0x0002       Model                            no
+  0x0003       Software                         no
+  0x0011       CreateDate                       no
+  0x0012       DateTimeOriginal                 no
+  0x0013       FrameCount                       no
+  0x0016       FrameRate                        no
+  0x0019       TimeZone                         no
+  0x0022       FrameWidth                       no
+  0x0023       FrameHeight                      no
+  0x0032       AudioChannels                    no
+  0x0033       AudioBitsPerSample               no
+  0x0034       AudioSampleRate                  no
+  0x1002       NikonDateTime                    no
+  0x1013       ElectronicVR                     no
+  0x110829a    ExposureTime                     no
+  0x110829d    FNumber                          no
+  0x1108822    ExposureProgram                  no
+  0x1109204    ExposureCompensation             no
+  0x1109207    MeteringMode                     no
+  0x110920a    FocalLength                      no
+  0x110a431    SerialNumber                     no
+  0x110a432    LensInfo                         no
+  0x110a433    LensMake                         no
+  0x110a434    LensModel                        no
+  0x110a435    LensSerialNumber                 no
+  0x1200000    GPSVersionID                     no
+  0x1200001    GPSLatitudeRef                   no
+  0x1200002    GPSLatitude                      no
+  0x1200003    GPSLongitudeRef                  no
+  0x1200004    GPSLongitude                     no
+  0x1200005    GPSAltitudeRef                   no
+  0x1200006    GPSAltitude                      no
+  0x1200007    GPSTimeStamp                     no
+  0x1200008    GPSSatellites                    no
+  0x1200010    GPSImgDirectionRef               no
+  0x1200011    GPSImgDirection                  no
+  0x1200012    GPSMapDatum                      no
+  0x120001d    GPSDateStamp                     no
+  0x2000001    MakerNoteVersion                 no
+  0x2000005    WhiteBalance                     no
+  0x2000007    FocusMode                        no
+  0x200000b    WhiteBalanceFineTune             no
+  0x200001b    CropHiSpeed                      no
+  0x200001e    ColorSpace                       no
+  0x200001f    VRInfo                           Nikon VRInfo
+  0x2000022    ActiveD-Lighting                 no
   0x2000023    PictureControlData               Nikon PictureControl
+                                                Nikon PictureControl2
+                                                Nikon PictureControl3
+                                                Nikon PictureControlUnknown
   0x2000024    WorldTime                        Nikon WorldTime
-  0x2000032    UnknownInfo                      Nikon UnknownInfo
-  0x2000083    LensType                         N
-  0x2000084    Lens                             N
+  0x2000025    ISOInfo                          Nikon ISOInfo
+  0x200002a    VignetteControl                  no
+  0x200002c    UnknownInfo                      Nikon UnknownInfo
+  0x2000032    UnknownInfo2                     Nikon UnknownInfo2
+  0x2000039    LocationInfo                     Nikon LocationInfo
+  0x2000083    LensType                         no
+  0x2000084    Lens                             no
+  0x2000087    FlashMode                        no
+  0x2000098    LensData0100                     Nikon LensData00
+               LensData0101                     Nikon LensData01
+               LensData0201                     Nikon LensData01
+               LensData0204                     Nikon LensData0204
+               LensData0400                     Nikon LensData0400
+               LensData0402                     Nikon LensData0402
+               LensData0403                     Nikon LensData0403
+               LensData0800                     Nikon LensData0800
+               LensDataUnknown                  Nikon LensDataUnknown
+  0x20000a7    ShutterCount                     no
+  0x20000a8    FlashInfo0100                    Nikon FlashInfo0100
+               FlashInfo0102                    Nikon FlashInfo0102
+               FlashInfo0103                    Nikon FlashInfo0103
+               FlashInfo0106                    Nikon FlashInfo0106
+               FlashInfo0107                    Nikon FlashInfo0107
+               FlashInfoUnknown                 Nikon FlashInfoUnknown
+  0x20000ab    VariProgram                      no
+  0x20000b1    HighISONoiseReduction            no
+  0x20000b7    AFInfo2                          Nikon AFInfo2
+  0x20000c3    BarometerInfo                    Nikon BarometerInfo
 
 =head3 Nikon MOV Tags
@@ -7449,15 +13531,15 @@
 This information is found in MOV and QT videos from some Nikon cameras.
 
-   Index   Tag Name                             Writable
-   -----   --------                             --------
-      0    Make                                 N
-     24    Model                                N
-     38    ExposureTime                         N
-     42    FNumber                              N
-     50    ExposureCompensation                 N
-     68    WhiteBalance                         N
-     72    FocalLength                          N
-    175    Software                             N
-    223    ISO                                  N
+  Index1   Tag Name                             Writable
+  ------   --------                             --------
+      0    Make                                 no
+     24    Model                                no
+     38    ExposureTime                         no
+     42    FNumber                              no
+     50    ExposureCompensation                 no
+     68    WhiteBalance                         no
+     72    FocalLength                          no
+    175    Software                             no
+    223    ISO                                  no
 
 =head3 Nikon AVI Tags
@@ -7468,7 +13550,7 @@
   ------   --------                             --------
   'nctg'   NikonTags                            Nikon AVITags
-  'ncth'   ThumbnailImage                       N
+  'ncth'   ThumbnailImage                       no
   'ncvr'   NikonVers                            Nikon AVIVers
-  'ncvw'   PreviewImage                         N
+  'ncvw'   PreviewImage                         no
 
 =head3 Nikon AVITags Tags
@@ -7479,27 +13561,27 @@
   Tag ID   Tag Name                             Writable
   ------   --------                             --------
-  0x0003   Make                                 N
-  0x0004   Model                                N
-  0x0005   Software                             N
-  0x0006   Equipment                            N
-  0x0007   Orientation                          N
-  0x0008   ExposureTime                         N
-  0x0009   FNumber                              N
-  0x000a   ExposureCompensation                 N
-  0x000b   MaxApertureValue                     N
-  0x000c   MeteringMode                         N
-  0x000f   FocalLength                          N
-  0x0010   XResolution                          N
-  0x0011   YResolution                          N
-  0x0012   ResolutionUnit                       N
-  0x0013   DateTimeOriginal                     N
-  0x0014   CreateDate                           N
-  0x0016   Duration                             N
-  0x0018   FocusMode                            N
-  0x001b   DigitalZoom                          N
-  0x001d   ColorMode                            N
-  0x001e   Sharpness                            N
-  0x001f   WhiteBalance                         N
-  0x0020   NoiseReduction                       N
+  0x0003   Make                                 no
+  0x0004   Model                                no
+  0x0005   Software                             no
+  0x0006   Equipment                            no
+  0x0007   Orientation                          no
+  0x0008   ExposureTime                         no
+  0x0009   FNumber                              no
+  0x000a   ExposureCompensation                 no
+  0x000b   MaxApertureValue                     no
+  0x000c   MeteringMode                         no
+  0x000f   FocalLength                          no
+  0x0010   XResolution                          no
+  0x0011   YResolution                          no
+  0x0012   ResolutionUnit                       no
+  0x0013   DateTimeOriginal                     no
+  0x0014   CreateDate                           no
+  0x0016   Duration                             no
+  0x0018   FocusMode                            no
+  0x001b   DigitalZoom                          no
+  0x001d   ColorMode                            no
+  0x001e   Sharpness                            no
+  0x001f   WhiteBalance                         no
+  0x0020   NoiseReduction                       no
 
 =head3 Nikon AVIVers Tags
@@ -7507,15 +13589,22 @@
   Tag ID   Tag Name                             Writable
   ------   --------                             --------
-  0x0001   MakerNoteType                        N
-  0x0002   MakerNoteVersion                     N
+  0x0001   MakerNoteType                        no
+  0x0002   MakerNoteVersion                     no
 
 =head2 NikonCustom Tags
 
+Unfortunately, the NikonCustom settings are stored in a binary data block
+which changes from model to model.  This means that significant effort must
+be spent in decoding these for each model, usually requiring hundreds of
+test images from a dedicated Nikon owner.  For this reason, the NikonCustom
+settings have not been decoded for all models.  The tables below list the
+custom settings for the currently supported models.
+
 =head3 NikonCustom SettingsD40 Tags
 
 Custom settings for the Nikon D40.
 
-   Index   Tag Name                             Writable
-   -----   --------                             --------
+  Index1   Tag Name                             Writable
+  ------   --------                             --------
     0.1    Beep                                 int8u & 0x80
     0.2    AFAssist                             int8u & 0x40
@@ -7545,6 +13634,6 @@
 Custom settings for the Nikon D80.
 
-   Index   Tag Name                             Writable
-   -----   --------                             --------
+  Index1   Tag Name                             Writable
+  ------   --------                             --------
     0.1    Beep                                 int8u & 0x80
     0.2    AFAssist                             int8u & 0x40
@@ -7600,6 +13689,6 @@
 Custom settings for the D90.
 
-   Index   Tag Name                             Writable
-   -----   --------                             --------
+  Index1   Tag Name                             Writable
+  ------   --------                             --------
     0.1    LightSwitch                          int8u & 0x08
     2.1    AFAreaModeSetting                    int8u & 0x60
@@ -7661,6 +13750,6 @@
 Custom settings for the D3, D3S, D3X, D300 and D300S.
 
-   Index   Tag Name                             Writable
-   -----   --------                             --------
+  Index1   Tag Name                             Writable
+  ------   --------                             --------
     0.1    CustomSettingsBank                   int8u & 0x03
     0.2    CustomSettingsAllDefault             int8u & 0x80
@@ -7736,10 +13825,17 @@
    20.2    FlashShutterSpeed                    int8u & 0x0f
    21.1    AutoBracketSet                       int8u & 0xc0
+           AutoBracketSet                       int8u & 0xe0
    21.2    AutoBracketModeM                     int8u & 0x30
+           AutoBracketModeM                     int8u & 0x18
    21.3    AutoBracketOrder                     int8u & 0x08
+           AutoBracketOrder                     int8u & 0x04
    21.4    ModelingFlash                        int8u & 0x01
    22.1    NoMemoryCard                         int8u & 0x80
    22.2    MeteringTime                         int8u & 0x0f
    23.1    InternalFlash                        int8u & 0xc0
+   25.1    ImageReviewTime                      int8u & 0xe0
+   25.2    PlaybackMonitorOffTime               int8u & 0x1c
+   26.1    MenuMonitorOffTime                   int8u & 0xe0
+   26.2    ShootingInfoMonitorOffTime           int8u & 0x1c
 
 =head3 NikonCustom SettingsD700 Tags
@@ -7747,6 +13843,6 @@
 Custom settings for the D700.
 
-   Index   Tag Name                             Writable
-   -----   --------                             --------
+  Index1   Tag Name                             Writable
+  ------   --------                             --------
     0.1    CustomSettingsBank                   int8u & 0x03
     0.2    CustomSettingsAllDefault             int8u & 0x80
